// mudlib: Basis
// date:   1992/09/09

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/bin/daemon/RCS/aliasd.c,v $
  $Revision: 1.3 $
  $Author: garnett $
  $Date: 92/09/25 00:35:32 $
  $State: Exp $

  $Log:	aliasd.c,v $
 * Revision 1.3  92/09/25  00:35:32  garnett
 * added save_data to the remove alias
 * 
 * Revision 1.2  92/09/24  21:27:34  garnett
 * masked add_alias so that it causes a save to occur.
 * 
 * Revision 1.1  92/09/24  20:59:25  garnett
 * Initial revision
 * 
*/

#include <config.h>

inherit DAEMON;
inherit ALIAS;
inherit SAVE;

void
create()
{
	seteuid(getuid(this_object()));
	save::set_persistent(TRUE);
	alias::clear_aliases();
	save::create();
}

varargs int
add_alias(string verb, string cmd, int is_xalias)
{
	if (alias::add_alias(verb, cmd, is_xalias)) {
		save::save_data();  // force a save after each addition
		return 1;
	}
	return 0;
}

varargs int
remove_alias(string verb, int is_xalias)
{
	if (alias::remove_alias(verb, is_xalias)) {
		save::save_data();  // force a save after each removal
		return 1;
	}
	return 0;
}
