/* man.c -- Oct20/91 by Jubal@TMI */

/* man emulates the UNIX man.
*/


#include <config.h>
#include <man.h>

varargs string *find_manpage(string root, mixed arg, string name);


/* valid_man_read() returns 1 if this_player() is allowed to read the
        manpage given as the argument.  This module is mudlib dependent,
        and gods should change it to reflect the local levels of manpage
        access.  The default is to allow access to any manpage by any
        player.
*/

int valid_man_read( string *manentry ) {
        return 1;
}

varargs void man( mixed arg, string name ) {
	string *manent;

	seteuid(ROOT_UID);
	manent = find_manpage( "cat", arg, name );
	if( manent )
	{
		if( valid_man_read( manent ) )
		{

			this_player()->more( manent[2] );
		}
		else
			write( "man:  no permission\n" );
	}
	else
	{
		if( name )
			write( "man:  " + name + " not found in section " + arg + "\n" );
		else
			write( "man:  " + arg + " not found\n" );
	}
}



/* find_manpage() is a function which is inherited by the manpage
        daemons.
*/

varargs string *find_manpage( string root, mixed arg, string name ) {
        int i;
        string *rv;

        rv = allocate( 3 );

        /* check if we are searching in a particular directory */
        if( name )
        {
                rv[0] = arg; rv[1] = name;
                rv[2] = man_root + "/" + root + arg +
                        "/" + name + "." + arg;
                if( file_size( rv[2] ) <= 0 ) rv = NULL;
        }
        else
        {
                rv[1] = name = arg;
                for( i=0 ; i<sizeof(man_dirlist) ; i++ )
                {
                        rv[0] = arg = man_dirlist[i];
                        rv[2] = man_root + "/" + root + arg +
                                "/" + name + "." + arg;
                        if( file_size( rv[2] ) > 0 ) break;
                }
                if( i == sizeof( man_dirlist ) ) rv = NULL;
        }
        return rv;
}
/* EOF */
