/*
   mudlib:      Basis
   file:        /bin/daemon/sfmd.c
   author:      Truilkan
   created:     1992/09/26
   description: shared file manager daemon
*/

//  $Locker:  $
//
//  $Source: /usr/local/mud/libs/basis/bin/daemon/RCS/sfmd.c,v $
//  $Revision: 1.1 $
//  $Author: garnett $
//  $Date: 92/09/26 22:47:10 $
//  $State: Exp $

/*
  $Log:	sfmd.c,v $
 * Revision 1.1  92/09/26  22:47:10  garnett
 * Initial revision
 * 
 */

#include <config.h>
#include <attributes.h>

inherit DAEMON;
inherit SAVE;

mapping refs;
mapping locks;

void
reference(string file)
{
	if (undefinedp(refs[file])) {
		refs[file] = 1;
	} else {
		refs[file]++;
	}
}

void
dereference(string file)
{
	int count;

	if (!undefinedp(refs[file])) {
		count = refs[file]--;
		if (!count) {
			map_delete(refs, file);
		}
	}
}

string *
query_refs()
{
	return keys(refs);
}

string *
query_locks()
{
	return keys(locks);
}

string
query_lock(string file)
{
	return locks[file];
}

int
lock(string file)
{
	if (!undefinedp(locks[file])) {
		return 0;
	} else {
		locks[file] = getuid(this_player(1));
		return 1;
	}
}

int
unlock(string file)
{
	if (undefinedp(locks[file])) {
		return 0;
	} else {
		map_delete(locks, file);
		return 1;
	}
}

void
create()
{
	refs = ([]);
	locks = ([]);
	set_persistent(TRUE);
	save::create();
}
