#include <config.h>

inherit DAEMON;
inherit SAVE;

mapping universe;
int index;

void
create()
{
	index = 0;
	universe = ([]);
	set_persistent(TRUE); // cause create()/remove() to load/save data
	save::create();       // restore the datafile
}

int inew()
{
	mapping m;

	index++;
	m = ([]);
	universe[index] = m;
	return index;
}

void
idestruct(int id)
{
	map_delete(universe, id);
}

void
iset(int id, mixed key, mixed value)
{
	mapping obj;

	if (undefinedp(obj = universe[id])) {
		return;
	}
	obj[key] = value;
}

void
iunset(int id, mixed key)
{
	mapping obj;

	if (undefinedp(obj = universe[id])) {
		return;
	}
	map_delete(obj, key);
}

mixed
iquery(int id, mixed key)
{
	mapping obj;

	if (undefinedp(obj = universe[id])) {
		return obj;
	}
	return obj[key];
}
