/* File: creator_file(), a simul_efun.
// Description: Gives the name of the creator of a file. 
// Cheerfully modularized by Buddha (2-18-92)
// This is a part of the TMI distribution mudlib.
// Please keep the header file if you use it.
*/

string creator_file(string str)
{
   string *path;
   int i;
   
   path = explode(str, "/");
   if (!path) return 0;
   
// Here's where all the permissions are sorted into uid's.
// This is very important.

	switch (path[0]) {
	case "adm":
		return ROOT_UID;
	case "bin":
		switch (path[1]) {
		case "maker":
			return MAKER_UID;
		case "admin":
			return ADMIN_UID;
		case "user":
			return USER_UID;
		case "root":
			return ROOT_UID;
		}
		return WORLD_UID;
	case "std":
		return STD_UID;
	case "obj":
		if (path[1] == "i") {
			return INTERACTIVE_UID;
		} else {
			return BACKBONE_UID;
		}
	case "room":
		return ROOM_UID;
	case "u":
		if (path[2] && path[3]) {
			return path[2];
		}
		break;
	case "d":
		return capitalize(path[1]);
	default:
		return WORLD_UID;
	}
	return WORLD_UID;
}
