// name:   items.c
// mudlib: Basis
// date:   1992/09/07
// author: Truilkan

// items are pseudo-objects; however, because Basis objects are mostly
// just collections of attributes plus optional code, these pseudo-objects
// may be viewed as objects without code (and without the overhead of
// standard objects).  The main drawback is the item must be
// specified as the first argument of each call (however this could
// be viewed as similar to the call_other(object, func, arg) syntax).

// item version of new (clone_object)

mapping inew()
{
	return allocate_mapping(0);
}

// item version of set

void iset(mapping item, mixed key, mixed value)
{
	item[key] = value;
}

// item version of query

mixed iquery(mapping item, mixed key)
{
	return item[key];
}
