// file:   /adm/obj/simul_efun/overrides.c
// mudlib: Basis

#include <config.h>
#include <attributes.h>
#include <login.h>

// only BASE can override move_object simul_efun

varargs void
move_object(object one, object two)
{
	write("Illegal move_object() call from "
		+ file_name(previous_object()) + "\n");
	write("move_object() may only be called from " + BASE
		+ ".\nUse anObject->move(dest) instead.\n");
}

void
destruct(object destructee)
{
	object destructor;

	destructor = previous_object();
	if ((destructee == master())
		&& (base_name(destructor) != NEW_MASTER_OB))
	{
		return;
	}
	efun::destruct(destructee);
}

varargs void
shutdown(int code)
{
	object prev;

	prev = previous_object();
	if (geteuid(prev) != ROOT_UID) {
		return;
	}
	seteuid(geteuid(prev));
	log_file("shutdowns", "Game shut down by "
		+ (string)prev->query(a_cap_name) + " at " +
		ctime(time()) + "\n");
	efun::shutdown(code);
}

// disallow snooping for now

object
snoop(object snoopee)
{
    return 0;
}

int
exec(object to_obj, object from_obj)
{
	string prev;

	prev = base_name(previous_object());
	if ((prev == SU_OB) || (prev == LOGIN_OB) || (prev == NEW_USER)) {
		return efun::exec(to_obj, from_obj);
	}
	return 0;
}
