// mudlib: Basis
// note:   heavily based on Pinkfish's pluralizer (but simplified since this
//         one isn't meant to handle nouns or articles etc)

#define VOWELS ({'a', 'e', 'i', 'o', 'u'})

string pluralize_verb(string rel)
{
	string two;
	int i, ch, len;

	if (!stringp(rel) || ((len = strlen(rel)) < 2)) {
		return ""; 
	}
    // trap the exceptions to the rules below and special cases.
	switch (rel) {
	case "half" :
		return "halves";
	case "fish" :
		return rel;
	}
	i = len - 1;
	ch = rel[i];
	//
	// *x -> *xes (fox -> foxes)
	// *s -> *ses (pass -> passes)
	// *ch -> *ches (church -> churches)
	// *sh -> *shes (brush -> brushes)
	two = rel[(i - 1) .. i];
	if ((ch == 's') || (ch == 'x') || (two == "ch") || (two == "sh")) {
		return rel + "es";
	}
	if (two == "is") {
		return rel + "ses";
	}
	if (two == "iz") {
		return rel + "zes";
	}
	// *ife -> *ives (knife -> knives)
	if (rel[(i - 2) .. i] == "ife") {
		return rel[0 .. (i - 2)] + "ves";
	}
	// *y -> *ies (gumby -> gumbies)
	if ((ch == 'y') && (member_array(rel[i - 1], VOWELS) == -1)) {
		return rel[0 .. (i - 1)] + "ies";
	}
	// default: (* -> *s)
	return rel + "s";
}

// EOF
