// mudlib: Basis
// file:   replace_string.c
// date:   1992/09/24

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/adm/obj/simul_efun/RCS/replace_string.c,v $
  $Revision: 1.1 $
  $Author: garnett $
  $Date: 92/09/25 05:00:45 $
  $State: Exp $

  $Log:	replace_string.c,v $
 * Revision 1.1  92/09/25  05:00:45  garnett
 * Initial revision
 * 
*/

/*
// File: replace_string.c
// Author: Wayfarer@Portals,TMI
// Purpose: a simple function to replace one string with another.
// Now a part of the TMI distribution mudlib.
*/

#if 0 /* is now an efun */
string
replace_string(string format, string orig, string new)
{
	string front, back, tmp;

	if (!format) {
		return new;
	}
	tmp = "%s" + orig + "%s";
	if (sscanf(format, tmp, front, back) == 0) {
		return format;
	}
	if (!front) {
		front = "";
	}
	if (!back) {
		back = "";
	}
	return front + new + back;
}
#endif

// replace_words: loosely based on code from Portals

string
replace_words(string orig, string rest)
{
	string *parts, *words;
	int i, num;

	parts = explode(orig, "$");
	if ((sizeof(parts) == 1) && (orig[0] != '$')) {
		return orig;
	}
	for (i = 0; i < sizeof(parts); i++) {
		if (parts[i][0] == '*') {
			parts[i] = replace_string(parts[i], "*", rest);
		} else {
			if (sscanf(parts[i], "%d", num) != 1) {
				continue;
			}
			if (!words) {
				words = explode(rest, " ");
			}
			if ((num > 0) && (num <= sizeof(words))) {
				parts[i] = replace_string(parts[i], num + "", words[num-1]);
			}
		}
	}
	if (sizeof(parts) == 1) { // avoid the expense of an implode()
		return parts[0]; 
	} else {
		return implode(parts, "");
	}
}
