/*
   mudlib:  base
   file:    /adm/std/login/new_user.c
   created: 1992/07/28
*/

#include <config.h>
#include <login.h>

private object new_obj;

// handle_new_user: this function gets called in the event that
// a player logs in using a name that is currently not in use.  Different
// muds may wish to do different things in this situation.  An open mud
// might create a new character at this point.  A more closed mud might
// display a message stating who to email to request an account.  An even
// tighter mud would display the password prompt and write MSG_BAD_PASSWORD
// regardless of the user input (thus the potential player wouldn't even be
// able to discern who had accounts and who didn't -- this is the way UNIX
// handles it).  This latter two methods would require additional support for
// creating characters (other than that provided in the above "choice"
// function).

void handle_new_user(string name)
{
    write("Is " + capitalize(name) + " the name you want? (y or n): ");
    input_to("choice", name);
}

void
choice(string answer, string name)
{
    write("\n");
    if (no(answer)) {
        write(NEW_NAME_PROMPT);
        input_to("get_name");
        return;
    }
    else if (yes(answer)) {
	if (this_object()->check_mail_site(query_ip_number())) {
	    if (new_obj) destruct(new_obj);
	    destruct(this_object());
	    return;
	}
	new_obj = new(NEW_USER);
	seteuid(name);
	export_uid(new_obj);
	seteuid(ROOT_UID);
	if (exec(new_obj, this_object())) {
		new_obj->setup(name);
	} else {
		write(MSG_BAD_NEW_PLAYER_OBJ);
		destruct(new_obj);
	}
        return;
    }
    write("Unacceptable choice, please type y or n: ");
    input_to("choice", name);
    return;
}
