#include <config.h>
#include <access.h>

// todo: get rid of these #defines

mapping access = ([]);

string remove_white_space(string str)
{
   str = implode(explode(str," "),"");
   str = implode(explode(str,"\t"),"");
   return str;
}

void error_out(string msg, int line)
{
   write("ERROR! "+ACCESS_FILE +" contains bad "+msg+" in line "+line+"\n");
}

mapping load_access()
{
   string *lines;
   string file;
   int i,j,k;
   string *rest;
   int setbits;
   string path;
   string tmp,name;

   access = ([]);
   seteuid(ROOT_UID);
   if((file = read_file(ACCESS_FILE)) == "")
   {
      write("Error loading access file!\n");
      return access;
   }

   lines = explode(file,"\n");

   for(i = 0; i < sizeof(lines); i++)
   {
      lines[i] = remove_white_space(lines[i]);
      if(lines[i][0] == '#' || lines[i] == "")
         continue;
      if(!sscanf(lines[i],"(%s)%s",path,lines[i]))
      {
         error_out("path",i + 1);
         return ([]);
      }
      rest = explode(lines[i],":");
      for(j = 0; j < sizeof(rest); j++)
      {
         if(!sscanf(rest[j],"%s[%s]",name,tmp))
         {
            error_out("name",i + 1);
            return 0;
         }

         if(name[0] == '(' && name[strlen(name) - 1] == ')')
            name = "@"+name[1 .. strlen(name) - 2];

         if(!access[path]) {
            access[path] = ([]);
         }

         access[path][name] = 0;
	 for(k = 0; k < strlen(tmp); k++)
	 {
	    switch(tmp[k])
	    {
	       case 'r':
	          access[path][name] |= ACCESS_READ;
		  break;
	       case 'w':
		  access[path][name] |= ACCESS_WRITE;
		  break;
	    }
	 }
      }
   }
   return access;
}

mapping query_access(string str)
{
   return access[str] + ([]);
}

int check_groups(mixed *grps, string eff_user,string path)
{
  int i,res,found;
  string tmp;
  
  for(i = 0; i < sizeof(grps); i++)
    {
      if(grps[i][0] != '@')
	{
	  if(grps[i] == eff_user)
      {
         found = 1;
         res |= access[path][eff_user];
      }
	}
      else
	{
	  tmp = grps[i][1..strlen(grps[i]) - 1];
	  if(tmp == "all" || MASTER_OB->query_member_group(eff_user,tmp))
      {
         found = 1;
            res |= access[path][grps[i]];
      }
	}
    }
   return found ? res : -1;
}

int check_access (string str, object act_ob)
{
  string *pth;
  string eff_user, tmp;
  int res;
  
  eff_user = geteuid (act_ob);
  if (!eff_user) {
    eff_user = getuid(act_ob);
  }

  if (sscanf(str, user_path(eff_user) +"%s",tmp) == 1)
    return (ACCESS_READ | ACCESS_WRITE);
  pth = explode(str,"/");
  if(!pth)
    pth = ({});
 
  if( eff_user == BACKBONE_UID &&
     ( pth[0] == "obj" || pth[0] == "data" )) 
     return (ACCESS_READ | ACCESS_WRITE);
  while(1)
    {
      if(!sizeof(pth))
	str = "/";
      else
	str = "/"+implode(pth,"/");
	if (access[str])
	{
 	  res = check_groups(keys(access[str]),eff_user,str);
	  if(res >= 0)
	    {
	      return res;
	    }
	}
      if(str == "/")
	break;
      pth = pth[0 .. sizeof(pth) - 2];
    }
  return 0;
}
