// file: /std/bin/bin_m.c
// mudlib: Basis

// This file is part of the TMI Mudlib distribution.
// Please include this header if you use this code.
// Written by Sulam(Jan 19, 1992)
// Modified by Buddha(2-18-92)
// Modified by Truilkan (1992 Sept 5)

#include <uid.h>
#include <permissions.h>

#define MAX_PERMISSION 999

private static int permission = MAX_PERMISSION;

int do_command(string arg);

int
query_level()
{
    return permission;
}

static void
set_permission(int p)
{
   int np;

   if (undefinedp(p) || (p < 0) || (p > MAX_PERMISSION)) {
      p = MAX_PERMISSION;
   }
   switch (getuid(this_object())) {
      case USER_UID :  np = USER(p); break;
      case MAKER_UID : np = MAKER(p); break;
      case ADMIN_UID : np = ADMIN(p); break;
      case ROOT_UID :
      default :        np = ROOT(p); break;
   }
   permission = np;
}

int query_prevent_shadow()
{
   return 1;
}

void clean_up()
{
   destruct(this_object());
}

void create()
{
   seteuid(ROOT_UID);
   set_permission((int)this_object()->permissions());
}

int
execute(string arg, int upermission)
{
   if (permission >= MAKER_BIAS) {
      if (!interactive(previous_object()))
         return 0;
   }
   if (upermission < permission) {
      write("bin: Permission denied.\n");
      return 1;
   }
   return do_command(arg);
}

int permissions() { return 0; }

// EOF
