// file:    promote.c (newuser)
// author:  Truilkan
// date:    1992/11/11

#include <config.h>
#include <permissions.h>
#include <positions.h>
#include <attributes.h>
inherit BIN;

// todo: allow promoting of people that aren't logged in

static int
do_command(string arg)
{
	string user;
	int level, nlevel, olevel, myLevel;
	object pobj;

	if (!arg) {
		notify_fail("usage: promote user level\n");
		return 0;
	}
	sscanf(arg, "%s %d", user, level);
	if ((level < 0) || (level > 999)) {
		notify_fail("promote: level must be in the range 0-999.\n");
		return 0;
	}
	if (!(pobj = find_player(user))) {
		notify_fail("promote: couldn't find " + user + "\n");
		return 0;
	}
	switch ((string)pobj->query(a_position)) {
		case P_ROOT :
			nlevel = ROOT(level); break;
		case P_ADMIN :
			nlevel = ADMIN(level); break;
		case P_MAKER :
			nlevel = MAKER(level); break;
		case P_USER :
			nlevel = USER(level); break;
		default :
			nlevel = 0;
			break;
	}
	olevel = (int)pobj->query(a_permissions);
	myLevel = (int)this_player(1)->query(a_permissions);
	if (myLevel < olevel) {
		notify_fail("promote: insufficient permission.\n");
		return 0;
	}
	if (nlevel > myLevel) {
		notify_fail("promote: insufficient permission.\n");
		return 0;
	}
	pobj->set(a_permissions, nlevel);
	pobj->save_data();
	return 1;
}

int permissions() { return 900; }
