// Mudlib: Basis
// Date:   1992/09

/*
// This file is a part of the TMI distribution mudlib.
// Please retain this header if you use this code.
// Coded by Grog (10/15/91 - 11/03/91)
// Added to the /bin structure by Buddha  (1/18/91) 
// Help added by Brian (1/28/92)
*/

#include <config.h>
#include <attributes.h>
inherit BIN;

int
do_command(string str)
{
    string line;
    string file1;
    string file2;
    int localdest;

    seteuid(geteuid(previous_object()));
    localdest = 0;    /* Assume it's not a local destination */
    if (!str || sscanf(str, "%s %s", file1, file2) != 2) {
        notify_fail("usage: cp file1 file2\n");
        return 0;
    }
    /* check for last parameter == "." */
    if (file2 == ".") {
        localdest = 1;     /* It's a local destination */
        file2 = "";
    }
    /* Given the player's current working directory and the path(s)
       for the file, construct the new full path for both files */
    file1 = resolv_path(this_player()->query(a_cwd), file1);
    file2 = resolv_path(this_player()->query(a_cwd), file2);
  /* Check if the destination is a directory */
  if (!localdest) {
    if (file_size(file2) == -2)
      localdest = 1;
  }
  if (localdest) {
    /* Extract the root file name from the source and use
       it for the destination.  file2 should be just a
       directory path at this point so that the rootname can
       be appended. */
    string newroot;
    string path;
    string rootname;
    rootname = file1;
    while(sscanf(rootname, "%s/%s", path, newroot) == 2) {
      rootname = newroot;
    }
    file2 = file2 + "/" + rootname;
  }
  if (file1 == file2) {
    notify_fail("cp: can not copy a file on top of itself!\n");
    return 0;
  }
  if (!MASTER_OB->valid_read(file1,(string)this_player()->query(a_uid), "cp"))
    {
    notify_fail(file1 + ": Permission denied.\n");
    return 0;
  }
  if (!MASTER_OB->valid_write(file2,(string)this_player()->query(a_uid), "cp"))
    {
    notify_fail(file2 + ": Permission denied.\n");
    return 0;
  }
  line = read_file(file1);
  if (line == 0) {
    /* Uhoh.  Can't read source file. */
    notify_fail("cp: file not found: " + file1 + "\n");
    return 0;
  }
  if (file_size(file2) == -2)
    {
    notify_fail("Tried to overwrite the directory "+ file2 + "\n");
    return 0;
  }
  rm(file2);
  write_file(file2, line);
  write("Copied: " + file1 + " to " + file2 + "\n");
  return 1;
}

int permissions() { return 50; }
