// Mudlib: Basis
// Date:   1992/09/07

/*
// The infamous "grep".
// Accepts wildcards.
*/

#include <config.h>
#include <attributes.h>
inherit BIN;

int do_command(string path, string prefix) {
   string *files,dir;
   string *lines;
   string *tmp;
   string file,pattern,filen;
   object act_ob;
   int i;
   
   if(!prefix)
      prefix = "";
   act_ob = previous_object();

   if(!path || !sscanf(path,"%s %s",pattern,filen))
      {
      notify_fail("usage: grep <pattern> <file>\n");
      return 0;
   }
   seteuid(getuid(act_ob));
   files = (string *)act_ob->wild_card(filen);
   if(!sizeof(files))
   {
      write("File not found.\n");
      return 1;
   }
   
   if(sizeof(files) > 1)
   {
      tmp = path_file(files);
      for(i = 0; i < sizeof(files); i++)
      {
         if(file_size(files[i]) < 0) continue;
			do_command(pattern+" "+files[i],tmp[1][i]+":");
      }
      return 1;
   }

   file = read_file(files[0]);
   if(!file)
   {
      write("File "+files[1]+" not found!\n");
      return 1;
   }
   lines = explode(file,"\n");
   lines = regexp(lines,pattern);
   for(i = 0; i < sizeof(lines); i++)
      write(prefix+lines[i]+"\n");
   return 1;
}

int permissions() { return 10; }
