// Mudlib: Basis
// Date:   1992/09/08

/*
// This file is part of the TMI Mudlib distribution.
// Please include this header if you use this code.
// Adapted by Buddha(1-18-91) from unknown source.
*/

#include <config.h>
#include <daemons.h>
#include <attributes.h>
inherit BIN;

int do_command(string str);
int help();


int
do_command(string str)
{
   string t1, t2, *tmp, locker;

	seteuid(geteuid(previous_object())); /* set it to the caller's perms */
	if(!str||sscanf(str,"%s %s",t1,t2)!=2) {
		/* We should add checks for flags here. */
		return help();  
	} else {
		t1 = resolv_path(this_player()->query(a_cwd), t1);
		if (locker = (string)SFM_D->query_lock(t1)) {
			if (locker != getuid(previous_object())) {
				notify_fail(t1 + " is locked by " + capitalize(locker) + "\n");
				return 0;
			} else {
				write("mv: warning - you have a lock on " + t1 + "\n");
			}
		}
		rename(t1, t2=resolv_path(this_player()->query(a_cwd), t2));
		if (file_size(t2) == -2) {
			tmp = explode(t1, "/");
			t2 += "/" + tmp[sizeof(tmp)-1];
		}
		write(
			((file_size(t1)<0)&&(file_size(t2)!=-1)) ? t1+" -> "+t2+"\n"
			:"mv failed.\n");
	}
	return 1;
}

int help() {
   write(
      "Syntax:\nmv <file1> <file2|directory>\n" +
      "Renames a file or moves it into the directory specified.\n" +
      "Currently this will overwrite an existing file, UNIX-like\n" +
      "behavior hasn't been added.\n");
   return 1;
}

/* EOF */

int permissions() { return 0; }
