// Mudlib: Basis
// Date:   1992/09

/*
// This file is part of the TMI Mudlib distribution.
// Please include this header if you use this code.
// Written by Sulam(1-8-92)
// Help added by Brian (1/28/92)
*/

#include <config.h>
#include <daemons.h>
#include <attributes.h>
inherit BIN;

int help();

int
do_command(string str)
{
	string locker;

	seteuid(geteuid(previous_object()));
	if( !str )
	{
                return help();
	}
	str = resolv_path(this_player()->query(a_cwd), str);
	if (locker = (string)SFM_D->query_lock(str)) {
		notify_fail(str + " is locked by " + capitalize(locker) + "\n");
		return 0;
	}
	switch( file_size(str) )
	{
		case -1:
			notify_fail("rm: "+str+": No such file.\n");
			return 0; break;
		case -2:
			notify_fail("rm:"+str+": directory\n");
			return 0; break;
	}
	if( (int)MASTER_OB->valid_write(str, previous_object()) == 0 )
	{
		notify_fail(str+": Permission denied.\n");
		return 0;
	}
	write(rm(str) ? "Ok.\n" : str+": remove failed.\n");
	return 1;
}

int
help()
{
  write("Command: rm\nSyntax: rm <file>\n"+
        "This command will erase the file specified.  It is possible\n"+
        "to specify files in other directories if desired, see help cd\n"+
        "for syntax.  This command will fail if you do not have the\n"+
        "proper priveledges to write to the file.\n");
  return 1;
}
/* EOF */
