// _apropos.c: written by Whiplash@TMI
// minor rewrite by Truilkan@TMI
//
// modeled after UNIX(tm) command man -k or apropos
// this command is different than "whatis" in that it returns all matches
// that contain the string in question.

inherit "/bin/bin_m";

#define APROPOS_D "/bin/daemon/aproposd"

int help() {
   write("usage: apropos topic\n");
   return 1;
}

int cmd_apropos(string str) {
   int i;
   string *all_match;

   if (!str) {
       help();
       return 1;
   }
   all_match = (string *)APROPOS_D->apropos(str);
   for (i = 0; i < sizeof(all_match); i++) {
      write(all_match[i] + "\n");
   }
   if (!i) {
      write("No matching entry.\n");
   }
   return 1;
}
