/*
// This file is part of the TMI Mudlib distribution.
// Please include this header if you use this code.
// Originally written by Sulam (sometime)
// Rewritten cause of grossity by Sulam(1-22-92)
// Help added by Brian (1/28/92)
*/

#include <move.h>
#include <daemons.h>
inherit "/bin/bin_m";

int
cmd_home(string str) {
    object prev;

    prev = environment(this_player());
    if (!str) str = user_path(geteuid(this_player()));
    else str = user_path(str);
    if (!str) {
	notify_fail(str+": couldn't find user\n");
	return 0;
    }
    if( (int)this_player()->move(str+"workroom") != MOVE_OK ) {
	notify_fail("You remain where you are.\n");
	return 0;
    }
    if( prev )
	tell_room(prev, this_player()->query_mhome() + "\n");
    this_player()->describe_current_room( this_player()->query_verbose() );
    say( this_player()->query_mmin() + "\n" );
    return 1;
}

int
help() {
  write("Command: home\nSyntax: home [player]\n"+
        "If no user is specified this command takes you to\n"+
        "your workroom.  If you do not have a workroom that\n"+
        "will load then you will go nowhere.  If you name a\n"+
        "player then you will be taken to that player's workroom\n"+
        "instead.\n");
  return 1;
}
/* EOF */
