/*
 * _call.c
 * description: call a function on an object
 * author: wayfarer
  * Modified by Huthar (2/20/90) to put in fancy arg passing
 */

#include <config.h>
inherit BIN;

int do_command(string arg)
{
   string obs, fun, args, tmp, *arglist;
   object ob;
   mixed ret;
   mixed *dummy;

   dummy = ({ 0,0,0,0,0,0,0,0,0,0 });

   notify_fail ("usage: call <object list> <function> <argument list>\n");
   if (!arg)
     return 0;
   sscanf (arg,"%s %s",obs,tmp);
   if (!tmp)
     return 0;
   sscanf (tmp,"%s %s",fun,args);
   if (!args)
     fun = tmp;
   ob = (object)previous_object()->parse_list(obs);
   if (!ob) {
      notify_fail ("Couldn't find object.\n");
      return 0;
   }
   if (!fun)
     return 0;
   if (!function_exists(fun,ob)) {
      notify_fail ("No such function in that object.\n");
      return 0;
   }
   arg = (mixed *)previous_object()->parse_args(args) + dummy;

   ret = (mixed)call_other(ob, fun, arg[0], arg[1], arg[2], arg[3],
      arg[4], arg[5], arg[6], arg[7], arg[8], arg[9]);

   write ("Returned : \n");
   write(dump_variable(ret)+"\n");
   return 1;
}

help()
{
    write(
   "This is Huthar's patcher. It allows you to do neat stuf!(tm) with arguments\n"+
      "that you can't do with the standard tracer. Basically it allows you to pass\n"+
      "multiple arguments of mixed types to the call_othered functions. Examples are:\n"
     +"\"string\" designates a string\n#820# is an integer\n"+
      "(@huthar:#1:bag) designates an object (uses tracer to parse object)\n"+
      "{array} designates an array. (Currently no nested arrays allowed)\n"+
      "(Don't put any spaces between arguments)\n\nExample:\n"+
      "call @huthar:bag test_function (@){\"test\"(here)#12#}#924#\n"+
      "LPC syntax would have been:\n"+
      "test_function(find_player(\"huthar\"),({ \"test\",environment(this_player()),\n"+
      "   12 )}, 12, 924);\n\n"+
      "Typical use would be: call here:#1 set_id {\"bag\"\"sack\"}\n");
}
