// make.c
// Author: Shadowhawk
//  $Locker: yorkjoe $
//
//  $Source: /usr/local/mud/libs/basis/bin/maker/objects/RCS/make.c,v $
//  $Revision: 1.1 $
//  $Author: yorkjoe $
//  $Date: 92/10/02 06:37:26 $
//  $State: Exp $

/*
  $Log:	make.c,v $
 * Revision 1.1  92/10/02  06:37:26  yorkjoe
 * Initial revision
 * 
 */

#include <config.h>
#include <daemons.h>
#include <attributes.h>
#include <search_paths.h>
#include <move.h>

inherit BIN;

int cont; /* Flag to keep track if ancestor can't be loaded. */

int
do_command(string str) {
  string *parents, *times;
  string file;
  int index;
  object curr;

  cont = 1;
  if (str) {
    file = resolv_path((string)this_player()->query(a_cwd), str);
    curr = find_object(file);
    if (!curr)
      COMMAND_D->where("update")->do_command(file);
    if (!(curr = find_object(file))) {
      write("Cannot load file: " + file + ".\n");
      write("Terminating make.\n");
      cont = 0;
      return 1;
    }
  } else {
    curr = environment(this_player());
    if (!curr) {
      write("You have no environment.\n");
      write("Terminating make.\n");
      return 1;
    }
  }
  parents = inherit_list(curr);
  if (parents)
    for (index = 1; index < sizeof(parents) && cont; index++)
      do_command("/" + parents[index]);
  if (!cont)
    return 1;
  times = stat(file);
  if (sizeof(times) == 0)
    times = stat(file + ".c");
  if (cont > 1 || times[1] > times[2]) {
    cont = 2; /* Indicating that an ancestor was updated. */
    COMMAND_D->where("update")->do_command(file);
  }
  return 1;
}

