/*
// alias command
*/

#include <config.h>
#include <attributes.h>
inherit BIN;

void alias_reset ();

int
do_command(string str)
{
  int i, sl;
  int index;
  string verb,cmd,*elements;
  object act_ob;
  mapping alias;

  act_ob = previous_object();
  if(str == "-clear")
    {
      act_ob->clear_aliases();
      return 1;
    }
  if(str == "-reset")
    {
      alias_reset();
      return 1;
    }
  alias = (mapping) act_ob->query_aliases();
  if(!str)
    {
      if (!mapp(alias)) {
          if(pointerp(alias)) write("Your alias mapping is a pointer!\n");
          if(intp(alias)) write("You alias mapping is an integer!\n");
          if(stringp(alias)) write ("Your alias mapping is a string!\n");
          if(alias == 0) write ("You alias mapping is 0!\n");
          notify_fail("You have some bad aliases, dude!\n");
          return 0;
      }
      elements = keys(alias);
      if(!elements || !sizeof(elements))
   {
     write("No aliases defined.\n");
     return 1;
   }
      for(i = 0; i < sizeof(elements); i++)
   printf("%-15s%s\n",elements[i],alias[elements[i]]);
      return 1;
    }
  
  if(sscanf(str,"%s %s",verb,cmd) == 2)
    {
      if(verb=="alias")
   {
     notify_fail ("Sorry, you can't alias 'alias'.\n");
     return 0;
   }
   if (!alias[verb])
     write("Alias: "+verb+" ("+cmd+") added.\n");
   else
     write("Alias: "+verb+" ("+cmd+") altered.\n");
      act_ob->add_alias(verb,cmd);
      return 1;
    }
  if(!alias[str])
    {
      write("The alias "+str+" wasn't found.\n");
      return 1;
    }
  printf("%-15s%s\n",str,alias[str]);
  return 1;
}


varargs void alias_reset()
{
  
  if (!interactive(previous_object()))
    return;
  write("In alias reset.\n");
  do_command("exa look at $*");
  do_command("i inventory");
  do_command("l look $*");
  do_command("$' say $*");
  do_command("$\" say $*");
  do_command("$: emote $*");
  do_command("e east");
  do_command("w west");
  do_command("n north");
  do_command("s south");
  do_command("u up");
  do_command("d down");
  do_command("ne northeast");
  do_command("nw northwest");
  do_command("sw southwest");
  do_command("se southeast");
}


int help()
{
  write("Flags accepted:\n");
  write("    -reset\tClears aliases and sets them to defaults.\n");
  write("    -clear\tClears all aliases.\n");
  
  write("\nalias\t\t\tView current aliases.\n");
  write("alias <alias> <command>\tSet the verb alias to execute command.\n");
  write("alias <alias>\t\tCheck the value of <alias>\n");
  write("unalias <alias>\t\tRemove <alias> from the alias list.\n");
  
  write("\nSubstitution variable that exist are:\n");
  write("    $# - Where # is the number of the word after the verb to substitute.\n");
  write("    $* - Will be substituted with everything after the verb.\n");
  write("\nPrefixing the alias' verb with a $ allows you to set up a verb that does not\n");
  write("require a space after it. i.e. 'alias $' say $*' will allow you to do says as:\n");
  write("'Hey! This is most Stufly!\n");
  write("\nLook at the default aliases for examples.\n");
  return 1;
}

int permissions() { return 0; }
