#include <config.h>
inherit BIN;

int
do_command(string path)
{
   int max, m, i, ci, tmp;
   int size_max;
   int cc,mc;
   string *dir;
   mixed *data;
   string *output;
   int total,numdirs;
   string ls_path;
   int verbose;
   string xx,yy;
   object myself;

   myself = this_player();

   if (path) path += " ";
   while (path && sscanf(path, "-%s %s",xx,yy) == 2)
   {
      path = yy;
      switch (xx)
      {
         case "o":
         case "O":
            verbose = 0;
            break;
         case "s":
         case "S":
            verbose = 1;
            break;
         case "l":
         case "L":
            verbose = 2;
            break;
         default:
            write("Illegal switch:  " + xx + ".\n");
      }
   }
   if (path) path = path[0..(strlen(path) - 2)];
   ls_path = path;
   if (ls_path[strlen(ls_path) - 1] != 47)
      ls_path += "/";
   dir = stat(ls_path);
   if (!dir)
   {
      write("No such directory:  " + ls_path + "\n");
      return 1;
   }
   max = sizeof(dir);
   data = allocate(max);
   for (i = 0; i < max; i++)
   {
      data[i] = stat(ls_path + dir[i]);
      if (!data[i])
      {
         write("Cannot read directory:  " + ls_path + "\n");
         return 1;
      }
   }
   max = 0;
   if (verbose == 2)
   {
      max = sizeof(dir);
      output = allocate(max + 1);
      for (i = 0; i < max; i++)
      {
         if (sizeof(data[i]) == 1)
         {
            numdirs++;
            output[i] = sprintf("<directory>                          %s",
               dir[i]);
         }
         else
         {
            total += data[i][0];
            output[i] = sprintf("%-21s %11d %s",ctime(data[i][1]),
               data[i][0],dir[i]);
         }
      }

      output[max] = "total bytes:  " + total + "; files:  " +
          (max - numdirs) + "; subdirectories:  " + numdirs + "\n";
   }
   else
   {
      m = sizeof(dir);
      for (i = 0; i < m; i++)
      {
	      if (sizeof(data[i]) == 1)
         {
            dir[i] += "/";
            numdirs++;
         }
         else
         {
            total += data[i][0];
            if (verbose)
            {
               data[i][0] = (data[i][0] + 1023) >> 10; /* we want K, not bytes */
               if (data[i][0] > size_max)
                  size_max = data[i][0];
            }
         }
         tmp = strlen(dir[i]);
         if (tmp >= max)
            max = tmp + 1;
      }
      size_max = strlen(size_max + "");
      if (verbose)
         mc = 78 / (max + size_max + 1);  /* # of columns */
      else mc = 78 / (max ? max : 1);
      if (mc <= 0) mc = 1;
      output = ({ "" });
      for (i = 0; i < m; i++)
      {
	      if (cc >= mc)
         {
            output += ({ "" });
            cc = 0;
            ci++;
	      }
         cc++;
         if (verbose)
         {
   	      if (sizeof(data[i]) == 1)
               output[ci] += sprintf("%" + size_max + "s %-" + (cc < mc ?
                  max+"" : "") + "s","",dir[i]);
            else
               output[ci] += sprintf("%" + size_max + "d %-" + (cc < mc ?
                  max+"" : "") + "s",data[i][0],dir[i]);
         }
         else output[ci] += sprintf("%" + (cc < mc ? ("-" + max) : "") + "s",
            dir[i]);
      }
      output += ({ "total bytes:  " + total + "; files:  " +
          (m - numdirs) + "; subdirectories:  " + numdirs + "\n" });
   }
   myself->more(output);
   return 1;
}
