/*
// This file is part of the TMI distribution mudlib.
// Please include this header if you use this code in any way.
// Written by Sulam(12-12-91)
// Help added (1/28/92) by Brian
*/

#include "move.h"
inherit "/bin/bin_m";

int
help();

cmd_give(string str) {
   object ob, to;
   string what, who;
   int i;
   
    if (!stringp(str)) return help();
   if (sscanf(str,"%s to %s", what, who) != 2) {
      return help();
   }
   ob = present(what, this_player());
   if (!ob) {
      notify_fail("You must have an object to give it away!\n");
      return 0;
   }
   to = present(who, environment(this_player()));
   if (!to) {
      notify_fail("Give "+what+" to who?\n");
      return 0;
   }
   if (!living(to)) {
      notify_fail("Only living objects can accept items.\n");
      return 0;
   }
   i = (int) ob->move(to);
   switch(i) {
      case MOVE_OK: {
         write("You give " + ob->query_short() + " to " +
            to->query_cap_name() + ".\n");
         say(this_player()->query_cap_name()+" gives "+ob->query_short()+
            " to " + to->query_cap_name()+".\n",to);
         tell_object(to,this_player()->query_cap_name()+" gives you "+
            ob->query_short()+".\n");
         return 1;
         }
      case MOVE_NO_ROOM: {
         notify_fail(to->query_short()+" can't carry any more.\n");
         return 0;
         }
      default: {
         notify_fail("Oops, can't do that.\n");
         return 0;
         }
   }
}

int
help() {
  write("Command: give\nSyntax: give <item> to <player>\n"+
        "This command will make you give an item in your inventory\n"+
        "to the player specified.  You must be in the same room for\n"+
        "this to occur.\n");
  return 1;
}

int permissions() { return 0; }
