// ready.c
//
// This file details the "ready" command (also "wield", "wear", and
// "equip" - all 4 do the same thing).

#include <config.h>
#include <attributes.h>

inherit BIN;

int
do_command(string arg) {
  object item;
  int loc;

  item = present(arg, this_player());
  if (!item) {
    notify_fail("You don't have any item called " + arg + ".\n");
    return 0;
  }
  loc = item->query(a_worn_at);
  if (undefinedp(loc)) {
    notify_fail("The item " + arg + " cannot be equipped.\n");
    return 0;
  }
  write("Equipping " + arg + "...\n");
  return 1;
}
