/*
// alias command
*/

#include <config.h>
#include <daemons.h>
#include <attributes.h>
inherit BIN;

static int global;

void
set_global(int what)
{
	global = what;
}

int
do_command(string str)
{
	int i, is_xalias;
	string verb, cmd, *elements, *xelements;
	object act_ob;
	mapping alias, xalias;
  
	if (global) {
		act_ob = find_object(ALIAS_D);
	} else {
		act_ob = previous_object();
	}
	if (str == "-clear") {
		act_ob->clear_aliases();
		return 1;
	}
	alias = (mapping)act_ob->query_aliases();
	xalias = (mapping)act_ob->query_xaliases();
	if (!str) {
		elements = keys(alias);
		xelements = keys(xalias);
		if (!sizeof(elements) && !sizeof(xelements)) {
			write("No aliases defined.\n");
			return 1;
		}
		for (i = 0; i < sizeof(elements); i++) {
			printf("%-15s%s\n", elements[i], alias[elements[i]]);
		}
		for (i = 0; i < sizeof(xelements); i++) {
			printf("$%-14s%s\n", xelements[i], xalias[xelements[i]]);
		}
		return 1;
	}
  
	is_xalias = 0;
	if (str[0] == '$') {
		is_xalias = 1;
		str = str[1.. (strlen(str) - 1)];
	}
	if (sscanf(str,"%s %s", verb, cmd) == 2) {
		if (verb=="alias") {
			notify_fail ("Sorry, you can't alias 'alias'.\n");
			return 0;
		}
		if (is_xalias) {
			if (undefinedp(xalias[verb])) {
				write("Xalias: " + verb + " (" + cmd + ") added.\n");
			} else {
				write("Xalias: " + verb + " (" + cmd + ") altered.\n");
			}
		} else {
			if (undefinedp(alias[verb])) {
				write("Alias: " + verb + " (" + cmd + ") added.\n");
			} else {
				write("Alias: " + verb + " (" + cmd + ") altered.\n");
			}
		}
		act_ob->add_alias(verb, cmd, is_xalias);
		return 1;
	}
	if (undefinedp(alias[str])) {
		write("The alias "+str+" wasn't found.\n");
		return 1;
	}
	printf("%-15s%s\n", str, alias[str]);
	return 1;
}

void
create()
{
	set_global(0);
}

int permissions() { return 0; }
