// mudlib: Basis
// date:   1992/09/07

/*
// the "set" command
// Part of the TMI distribution mudlib (and Portals too!)
*/

#include "config.h"
#include <attributes.h>
inherit BIN;


int do_command(string arg)
{
  int i;
  string * vars;
  string val, var;
  mixed mix;
  object act_ob;
  
  act_ob = previous_object();
  if (!arg) {
      vars = (string *)act_ob->envars();
      if (!sizeof(vars)) {
	  notify_fail ("No environment variables set.\n");
	  return 0;
	}
      write ("Environment variables:\n");
      for (i = 0; i < sizeof (vars); i++) {
	  printf("%-15s%s\n",vars[i],(string)act_ob->getenv(vars[i]));
	}
      return 1;
    }
  if (sscanf(arg,"%s %s",var,val) != 2) {
      val = "";
      var = arg;
    }
  if(!(this_player(1) == previous_object() ||
      geteuid(previous_object()) == ROOT_UID) ) {
      write("Sorry, you are not allowed to set that variable.\n");
      return 1;
    }
  act_ob->setenv(var,val);
  write ("Variable added: "+var+"\n");
  return 1;
}

int permissions() { return 0; }
