/*
// The wonderful unalias command.
*/

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/bin/user/shell/RCS/unalias.c,v $
  $Revision: 1.3 $
  $Author: garnett $
  $Date: 92/09/25 01:01:53 $
  $State: Exp $

  $Log:	unalias.c,v $
 * Revision 1.3  92/09/25  01:01:53  garnett
 * fixed an alias[str] to be alias[tmp]
 * 
 * Revision 1.2  92/09/25  01:00:27  garnett
 * fixed it so that xaliases can be removed
 * 
 * Revision 1.1  92/09/25  00:52:30  garnett
 * Initial revision
 * 
*/

#include <config.h>
#include <daemons.h>
inherit BIN;

static int global;

void
set_global(int which)
{
	global = which;
}

int do_command(string str)
{
	mixed act_ob;
	mapping alias;
	int is_xalias;
	string tmp;

	if (!str) {
		notify_fail("usage: unalias <alias>\n");
		return 0;
	}

	if (global) {
		act_ob = ALIAS_D;
	} else {
		act_ob = previous_object();
	}
	alias = (mapping)act_ob->query_aliases()
		+ (mapping)act_ob->query_xaliases();

	if (str[0] == '$') {
		is_xalias = 1;
		tmp = str[1..(strlen(str) - 1)];
	} else {
		is_xalias = 0;
		tmp = str;
	}
	if (undefinedp(alias[tmp])) {
		write(str+": alias not found.\n");
		return 1;
	}

	write("alias: "+str+" ("+alias[tmp]+") Removed.\n");
	act_ob->remove_alias(tmp, is_xalias);
	return 1;
}

void
create()
{
	set_global(0);
}
