// file:   wizlist.c
// mudlib: Basis
// date:   1992/11/10
// author: Truilkan

#include <config.h>
inherit BIN;

void
header()
{
write(
"name         moves     objects  cost       errors  hb       worth    array\n"
);
write(
"---------    --------  -------  --------   ------  -------  -------  -------\n"
);
}

void
entry(string name, mapping e)
{
	printf("%-12s %8d  %7d  %8d  %7d  %7d  %7d  %7d\n", name,
		e["moves"], e["objects"], e["cost"], e["errors"], e["heart_beats"],
		e["worth"], e["array_size"]);
}

varargs mapping
get_stats(string arg)
{
	return arg ? domain_stats(arg) : domain_stats();
}

int
do_command(string arg)
{
	mapping list;
	string *makers;
	int j;

	if (arg) {
		list = this_object()->get_stats(arg);
		if (!list) {
			notify_fail("makers: couldn't find " + arg + ".\n");
			return 0;
		}
		header();
		entry(arg, list);
		return 1;
	}
	list = (mapping)this_object()->get_stats();
	makers = keys(list);
	header();
	for (j = 0; j < sizeof(makers); j++) {
		entry(makers[j], list[makers[j]]);
	}
	return 1;
}

int permissions() { return 0; }
