// file:   semote.c
// mudlib: Basis
// date:   1992/09/25

#include <config.h>
#include <daemons.h>
#include <emoted.h>

inherit BIN;

int
compare(string one, string two)
{
	return strcmp(one, two);
}

int
do_command(string arg)
{
	string *list;
	int j, len, count;

	if (arg) {
		int targeted;
		string verb, result;

		targeted = 0;
		if (sscanf(arg, "%s/t", verb)) {
			targeted = 1;
		} else {
			verb = arg;
		}
		if (targeted) {
			result = (string)EMOTE_D->query_temote(verb);
			if (result) {
				write(result);
			}
		} else {
			result = (string)EMOTE_D->query_emote(verb);
			if (result) {
				write(result);
			}
		}
		if (!result) {
			notify_fail("semote: unable to find " + arg + "\n");
		}
		return (result != 0);
	}
	list = sort_array((string *)EMOTE_D->query_keys(),"compare",this_object());
	count = 0;
	for (j = 0; j < sizeof(list); j++) {
		if (j) write(", ");
		if (!(++count % 10)) {
			write("\n");
		}
		write(list[j]);
	}
	write("\n");
	return 1;
}

int permissions() { return 0; }
