// file:   who
// mudlib: Basis
// date:   1992/09/07

/*
// This isn't part of the TMI distribution MudLib, though I hope it will
// eventually get incorportated.
//
// Written By Jubal @ TMI
// Sulam changed the title stuff 1/2/92
// Modified for time zones by DocZ @ TMI (1/20/92)
//
// Modified for players by Truilkan@TMI (02/15/92) -- eventually TMI
// will be used as the base for a real mud and real muds have real players
// that need player-type who commands (those that don't contain for-wizard
// eyes only information.  The original TMI who command has been renamed
// as "people")
*/

#include <config.h>
#include <daemons.h>
#include <attributes.h>
#include <writef.h>
inherit TIMEZONE_D;
inherit BIN;

string divide;

create()
{
	int i;

        ::create();
	for (divide = "", i = 0 ; i<78 ; i++ )
		divide += "_";
	divide += "\n";
}

void divider()
{
	write(divide);
}

int
do_command( string arg )
{
	object *list;
	string line, zone_name;
	int i,time_zone;

	if ( arg ) write("Arguments: "+arg+"\n");
	divider();
	list = users();
	if( sizeof( list ) > 1 )
		write( "\t\tThere are " + sizeof( list ) +
			" users connected.\n" );
	else
		write( "\t\tYou're the only one here.\n" );
	zone_name = (string)this_player()->getenv("TZONE");
	time_zone = query_tzone(zone_name);
	if (!time_zone) {
	  write( "\t\tMud time is " + ctime( time() ) + "\n" );
                 write("\t\t[Those contained in brackets are editing.]\n");
	} else {
	   write( "\t\t"+zone_name+" time is " + ctime ( time_zone ) + "\n" );
	}
	divider();

	write( writef( "Name", 65, QUIET ) + "  " +
		writef( "Idle", 4, QUIET ) + "\n");

	divider();

	for( i=0 ; i<sizeof(list) ; i++ ) {
		string field;
		mixed val;

		field = (string) list[i] -> query(a_eshort);
		if (in_edit(list[i]) || in_input(list[i]))
			field = "[" + field + "]";
		if( ! field ) field = "(null)";
		line = writef( field, 65, QUIET|TRUNC_RIGHT ) + "  ";

		val = query_idle( list[i] );
		if( val >= 3600 )
			field = val/3600 + "h";
		else if( val >= 60 )
			field = val/60 + "m";
		else field = "";
		line += writef( field, 4, QUIET|JFY_RIGHT );
		write( line + "\n" );
	}
	divider();
	return 1;
}

int permissions() { return 0; }

/* EOF */
