// room object used by the room description language compiler
// written by Truilkan@TMI - 92/05
// modified to work with Basis - 1992/11/05

// todo: add support for 'items', descriptions of exits, etc.

#include <config.h>
#include <attributes.h>
inherit BASE;

mapping objects;

void
clean_up()
{
   if (!sizeof(all_inventory(this_object()))) {
      this_object()->remove();
   }
}

void
make_object(string name, string path)
{
   object obj;

   if (!present(name, this_object())) {
      obj = new(path);
      obj->move(this_object());
   }
}

void
reset()
{
   string *names;
   object obj;
   int j;

   names = keys(objects);
   for (j = 0; j < sizeof(names); j++) {
      make_object(names[j], objects[names[j]]);
   }
}

void
add_object(string name, string path)
{
   objects[name] = path;
   make_object(name, path);
}

void
add_exit(string dest, string dir, string from)
{
    mapping anExit, exits;

    anExit = inew();
	exits = (mapping)this_object()->query(a_exits);
    iset(anExit, a_destination, dest);
    iset(anExit, a_arrives_from, from);
    // todo: fix room description language to handle short descripts for exits
    iset(anExit, a_eshort, "an ordinary exit");
    if (!exits) {
        this_object()->set(a_exits, ([ dir : anExit ]) );
    } else {
        this_object()->set(a_exits, exits + ([ dir : anExit ]) );
    }
}

void
set_long(string arg)
{
    this_object()->set(a_ilong, arg);
}

void
set_short(string arg)
{
    this_object()->set(a_eshort, arg);
}

int light(int l)
{
    return set_light(l);
}

void
create()
{
   seteuid(getuid(this_object()));
   objects = ([]);
   ::create();
}
