// written by Dwayne Fontenot (Jacques)
// last modified: 1992 October 19 (runs on the Basis mudlib)

// This object implements a telnet client (providing a subset of the telnet
// protocol) using STREAM mode of MudOS 0.9 LPC sockets.  See the init()
// function // to find out the commands this terminal understands.
// This object may be used from within a MudOS mud to connect to any
// networked server that understands the telnet protocol (including
// another LPmud).

#include <config.h>
#include <attributes.h>
inherit BASE;

inherit "/std/socket/telnet";

#define DISCONNECTED "an internet terminal"
#define CONNECTED "an internet terminal (connected)"

void create()
{
  base::create();
  telnet::create();
  seteuid(getuid(this_player()));
  set(a_ids, ({"terminal", "term", "tel"}) );
  set(a_eshort, DISCONNECTED);
  init_tel_neg();
}

void init()
{
  add_action("connect","connect");
  add_action("send","send");
  add_action("disconnect","disconnect");
  add_action("line","line");
  add_action("char","char");
}
