/*
// file: /std/player/history.c
// author: Portals (wayfarer and huthar)
// last modified: 1992/10/17 - Truilkan@Basis
*/

#include <adt_defs.h>

object queue;
int size;
string *history_queue;

void
initialize()
{
	size = this_object()->getenv("history");
	if (size) {
		queue = new(QUEUE_ADT);
		queue->alloc(size);
		history_queue = (string *)queue->query_queue();
	}
}

void
cleanup()
{
	history_queue = 0;
	queue->remove();
}

string
handle_history(string str)
{
   int tmp;
   string *tmpq;
   string *lines;
   string cmd;

   if (!queue) {
       return str;
   }
   if ((str[0] != '!') || (str == "!")) {
      queue->enqueue(str);
      return str;
   }

   if (!history_queue || (sizeof(history_queue) == 1)) {
      write(str[1 .. (strlen(str) - 1)] + ": Event not found.\n");
      return "";
   }
   if (str == "!!") {
      if ((tmp = ptr - 1) < 0) {
         tmp = max - 1;
      }
      cmd = history_queue[tmp];
   }
   else if (sscanf(str,"!%d",tmp)) {
      if (tmp > 0) {
         tmp -= cmd_num;
      }
      if (tmp >= 0 || (-tmp >= max)) {
         write(tmp + ": Event not found.\n");
         return "";
      }
      if ((tmp = ptr + tmp) < 0) {
         tmp = max + tmp;
      }
      cmd = history_queue[tmp];
   } else {
      str = str[1..(strlen(str) - 1)];
      if (!ptr) {
         tmpq = history_queue;
      } else {
         tmpq = history_queue[ptr..(max - 1)] + history_queue[0..(ptr - 1)];
      }

      lines = regexp(tmpq,"^" + str);
      if (!sizeof(lines)) {
         write(str + ": Event not found.\n");
         return "";
      }
      cmd = lines[sizeof(lines) - 1];
   }
   write(cmd + "\n");
   queue->enqueue(cmd);
   return cmd;
}
