/*
 * pager.c
 * description: the more command for the player object
 * author: wayfarer
 * last modified: 3/7/92
 */

string *wild_card (string arg);
static void search_forward (string arg);
static void search_reverse (string arg);
static void even_more(string str);
void do_more_file(string file);

#define CHUNK 23

static private string more_file, *lines, last_regexp, *files, chunkstr;
static private int more_line, from_file, num_lines, direction, chunk;
static private status use_get_char;

varargs void
get_char (string fun, int flag)
{
  if (use_get_char)
    efun::get_char(fun,flag);
  else
    input_to(fun,flag);
}

void
write_more_line()
{
  write (inverse("--More--("+((more_line*100)/num_lines)+"%)"));
}

varargs int
  more (mixed str, int flag)
{
  int i,j;
  string tmp;
  
  if (!str) 
    {
      notify_fail("usage: more <filename>\n");
      return 0;
    }
  direction = 1;
  last_regexp = "";
  more_line = 0;
  chunkstr = (string)this_object()->getenv("LINES");
  if (!chunkstr || !sscanf(chunkstr, "%d", chunk)) 
      chunk = CHUNK;
  if (this_object()->getenv("get_char"))
      use_get_char = 1;
   else use_get_char = 0;
  if (stringp(str)) 
    {
      from_file = 1;
      if (!flag)
	{
	  files = wild_card(str);
	  if (!sizeof(files))
	    {
	      notify_fail("No such file or directory.\n");
	      return 0;
	    }
	  while (1)
	    {
	      if(file_size(files[0]) < 0)
		{
		  if (sizeof(files) == 1)
		    {
		      notify_fail ("All zero length files.\n");
		      return 1;
		    }
		  files = files[1..(sizeof(files) - 1)];
		  continue;
		}
	      write("::::::::::::::\n"+files[j]+"\n::::::::::::::\n");
	      tmp = files[0];
	      if (sizeof(files) == 1)
		files = ({});
	      else
		files = files[1..(sizeof(files) - 1)];
	      more(tmp,1);
	      return 1;
	    }
	  return 1;
	}
      do_more_file(str);
      return 1;
    }
  else if (pointerp(str)) 
    lines = str;
  else 
    { 
      notify_fail ("Bad argument to more.\n"); 
      return 0; 
    }
  num_lines = sizeof(lines);
  if (!num_lines)
    return 1;
  even_more(" ");
  return 1;
}

void
do_more_file(string file)
{
  string tmp;
  more_file = file;
  more_line = 0;
  tmp = read_file (more_file);
  lines = explode(tmp,"\n");
  more (lines);
}

varargs void
next_more_file(string arg)
{
  if (!files || sizeof(files) == 0)
    return;
  if (!arg)
    {
      write("next file:\n"+
	    ":::::::::::::::::::::::\n"+files[0]+"\n::::::::::::::::::::::\n"+
	    "");
      get_char("next_more_file",1);
      return;
    }
  do_more_file(files[0]);
  if (sizeof(files) == 1)
    files = ({});
  else
    files = files[1..(sizeof(files) - 1)];
}

static void 
even_more(string str) 
{
  int i;
  
  str = str[0..0];   // this is just in case we use input_to and not get_char()
  switch (str)
    {
    case " ":
      break;
    case "":
      if (!use_get_char) break;
      write(erase_line());
      if (more_line >= sizeof(lines))
	return;
      write (lines[more_line]+"\n");
      more_line ++;
      write_more_line();
      get_char ("even_more",1);
      return;
      break;
    case "b":
    case "B":
      more_line -= chunk * 2;
      if (more_line < 0)
	{
	  more_line = chunk - 1;
	  get_char ("even_more",1);
	  return;
	}
      break;
    case "<":
      more_line = 0;
      break;
    case ">":
      more_line = sizeof(lines) - chunk;
      break;
    case "!":
      write(erase_line() + "!");
      input_to("exec_cmd");
      return;
      break;
    case "/":
      input_to ("search_forward");
      write(erase_line());
      write ("/");
      direction = 1;
      return;
      break;
    case "\\":
      input_to ("search_reverse");
      write(erase_line());
      write ("\\");
      direction = 0;
      return;
      break;
    case "n":
      if (!last_regexp || last_regexp == "")
	{
	  get_char("even_more",1);
	  return;
	}
      write(erase_line());
      if (direction == 1)
	search_forward (last_regexp);
      else
	search_reverse (last_regexp);
      return;
      break;
    case "=":
      write(erase_line());
      write ("" + more_line + " ");
      get_char ("even_more",1);
      return;
      break;
    case "v":
      write(erase_line());
      write ("more for tmi v1.0, written by wayfarer@portals ");
      get_char ("even_more",1);
      return;
      break;
    case "h":
    case "?":
      write(erase_line() + clear_screen());
      write ("------------------------------------------------------------------------------\n" +
	     "                          [more - help page]\n"+
	     "------------------------------------------------------------------------------\n" +
	     "<space>\t\t\tDisplay next page of text.\n"+
	     "B,b\t\t\tDisplay previous page of text.\n"+
	     "<return>\t\tDisplay next line of text.\n"+
	     "<\t\t\tGo to the beginning of the document.\n"+
	     ">\t\t\tGo to the end of the document.\n"+
	     "=\t\t\tDisplay the current line number.\n"+
	     "/\t\t\tRegexp search forward.\n"+
	     "\\\t\t\tRegexp search backward.\n"+
	     "n\t\t\tContinue last regexp search. (maintain direction)\n"+
	     "^L\t\t\tRedraw screen.\n"+
	     "!\t\t\tExecute a command in the mud.\n"+
	     "v\t\t\tPrint the version number.\n" +
	     "h,?\t\t\tPrint this help screen.\n"+
	     "Q,q\t\t\tQuit.\n"+
	     "");
      write_more_line();
      get_char ("even_more",1);
      return;
      break;
    case "":
      write (clear_screen());
      write (" [1;1f");
      more_line -= chunk;
      break;
    case "q":
    case "Q":
      write(erase_line());
      write ("\n"); 
      return;
      break;
    default:
      write(erase_line());
      write("Unrecognized command ");
      get_char("even_more",1);
      return;
      break;
    }
  write(erase_line());
  for (i = 0; i < chunk; i++)
    {
      if (more_line >= sizeof(lines))
	{
	  next_more_file();
	  return;
	}
      write (lines[more_line] + "\n");
      more_line++;
    }
  get_char ("even_more",1);
  write_more_line();
  chunkstr = (string)this_object()->getenv("LINES");
  if (!chunkstr || !sscanf(chunkstr, "%d", chunk))
      chunk = CHUNK;
  return;
}


static void
  search_forward (string arg)
{
  string *matches;
  int i;
  
  matches = regexp (lines[more_line .. (sizeof(lines) - 1)],arg);
  if (!matches || (sizeof(matches) == 0))
    {
      write(up_line()+erase_line()+"\n");
      write(inverse("Pattern not found"));
      get_char ("even_more",1);
      return;
    }
  for (i = more_line; i < sizeof(lines); i++)
    {
      if (matches[0] == lines[i])
	{
	  more_line = i;
	  write ("...skipping\n");
	  chunk -= 2;
	  even_more(" ");
	  last_regexp = arg;
	  return;
	}
    }
  return;
}

static void
search_reverse (string arg)
{
  string *matches;
  int i;

  matches = regexp (lines[0 .. (more_line - chunk - 1)],arg);
  if (!matches || (sizeof(matches) == 0))
    {
      write(up_line()+erase_line()+"\n");
      write(inverse("Pattern not found"));
      get_char ("even_more",1);
      return;
    }
  for (i = more_line - chunk - 1; i >= 0; i--)
    {
      if (matches[sizeof(matches) - 1] == lines[i])
	{
	  more_line = i;
	  even_more(" ");
	  last_regexp = arg;
	  return;
	}
    }
  return;
}


void
exec_cmd (string arg)
{
  this_player()->force_me(arg);
  write(erase_line()+"\n");
  write_more_line();
  get_char("even_more",1);
}

