// mudlib: Basis

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/std/user/RCS/shell.c,v $
  $Revision: 1.5 $
  $Author: garnett $
  $Date: 92/09/25 01:17:10 $
  $State: Exp $

  $Log:	shell.c,v $
 * Revision 1.5  92/09/25  01:17:10  garnett
 * changed so that global aliases are applied even if a local alias
 * gets applied.  this lets local aliases be written in terms of global
 * aliases (e.g. alias nod :nods)
 * 
 * Revision 1.4  92/09/25  00:19:22  garnett
 * fixed process_input so private aliases work right
 * 
 * Revision 1.3  92/09/24  21:04:14  garnett
 * added create that calls clear_aliases
 * 
 * Revision 1.2  92/09/24  20:51:41  garnett
 * changed to access global aliases daemon
 * 
 * Revision 1.1  92/09/24  20:21:42  garnett
 * Initial revision
 * 
*/

#include <daemons.h>

// file pager
inherit "/std/i/pager";
// standard editor object
inherit "/std/i/edit";
inherit "/std/i/alias";

string process_input(string arg)
{
    if (arg && (arg != "")) {
        arg = alias::do_alias(arg);
		arg = (string)ALIAS_D->do_alias(arg);
    }
    return arg;
}

void
create()
{
	alias::clear_aliases();
}
