// mudlib:  Basis
// file:    /std/living.c
// created: 1992/09/08

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/std/RCS/living.c,v $
  $Revision: 1.5 $
  $Author: garnett $
  $Date: 92/09/26 03:17:31 $
  $State: Exp $

  $Log:	living.c,v $
 * Revision 1.5  92/09/26  03:17:31  garnett
 * moved set_path call from create to setup
 * 
 * Revision 1.4  92/09/26  03:15:51  garnett
 * called set_path from create to set default of USER_SEARCH_PATH
 * 
 * Revision 1.3  92/09/26  03:13:25  garnett
 * add set_path... remove need for commandHook in inheritors
 * 
 * Revision 1.2  92/09/24  22:52:37  garnett
 * removed the xverb stuff since we have global aliases now (galias command)
 * 
 * Revision 1.1  92/09/24  06:16:11  garnett
 * Initial revision
 * 
*/

#include <config.h>
#include <attributes.h>
#include <daemons.h>
#include <search_paths.h>

inherit BASE;
inherit "/std/living/envars";

static string *path;

// set_path: only settable by this_object() (including inheritors)

static void
set_path(string *p)
{
	path = p;
}

int
commandHook(string args)
{
	object binObj;
	string verb;

	verb = query_verb();
	binObj = (object)COMMAND_D->find_bin_object(verb, path);
	if (binObj) {
		return (int)binObj->execute(args, query(a_permissions));
	} else {
		return (int)EMOTE_D->parse(verb, args);
	}
}

//  create: ::create() should be called by any object inheriting this one.

void
create()
{
	base::create();
	envars::create();
    enable_commands();
}
int
id(string arg)
{
     return (arg == query(a_name)) || ::id(arg);
}

void
setup()
{
    set_living_name(query(a_name));
	add_action("commandHook", "", 1);
    set_heart_beat(1);
	set_path(USER_SEARCH_PATH);
}

//  tell_me: useful for sending messages to this object.  using write()
//  is not appropriate because that sends the message to the caller
//  of the method which may in fact not be this_object().

void
tell_me(string message)
{
    this_object()->catch_tell(message);
}

// EOF
