//  mudlib:  Basis
//  file:    save.c
//  author:  Truilkan
//  created: 1992/09/24

/*
  $Locker:  $

  $Source: /usr/local/mud/libs/basis/std/RCS/save.c,v $
  $Revision: 1.3 $
  $Author: garnett $
  $Date: 92/10/01 02:32:07 $
  $State: Exp $

  $Log:	save.c,v $
 * Revision 1.3  92/10/01  02:32:07  garnett
 * make_data_dir is in master once again
 * 
 * Revision 1.2  92/10/01  02:29:36  garnett
 * called make_data_dir like a simul_efun instead of as if it were in master
 * 
 * Revision 1.1  92/09/24  19:24:32  garnett
 * Initial revision
 * 
*/

#include <config.h>
#include <daemons.h>

private static int persistent;

// set_persistent only callable by this_object() (including inheritors)

static void
set_persistent(int which)
{
	persistent = which;
}

void
save_data()
{
    string base;

    base = data_dir(this_object());
    if (!directory_exists(base)) {
        MASTER_OB->make_data_dir();
    }
    save_object(data_file(this_object()));
}

int
restore_data()
{
	string file;

	file = data_file(this_object());
	if (file_exists(file + ".o")) {
		return restore_object(data_file(this_object()));
	} else {
		return 0;
	}
}

void
remove()
{
	if (persistent) {
		save_data();
	}
	destruct(this_object());
}

void
create()
{
	// restore won't have any effect unless savefile exists
	restore_data();
}
